"use strict";
var options = require("./../../options");
var OpenDeviceLogStreamCommand = (function () {
    function OpenDeviceLogStreamCommand($devicesServices, $errors, $commandsService) {
        this.$devicesServices = $devicesServices;
        this.$errors = $errors;
        this.$commandsService = $commandsService;
        this.allowedParameters = [];
    }
    OpenDeviceLogStreamCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            _this.$devicesServices.initialize({ deviceId: options.device, skipInferPlatform: true }).wait();
            if (_this.$devicesServices.deviceCount > 1) {
                _this.$commandsService.tryExecuteCommand("device", []).wait();
                _this.$errors.fail(OpenDeviceLogStreamCommand.NOT_SPECIFIED_DEVICE_ERROR_MESSAGE);
            }
            var action = function (device) {
                return (function () { return device.openDeviceLogStream(); }).future()();
            };
            _this.$devicesServices.execute(action).wait();
        }).future()();
    };
    OpenDeviceLogStreamCommand.NOT_SPECIFIED_DEVICE_ERROR_MESSAGE = "More than one device found. Specify device explicitly.";
    return OpenDeviceLogStreamCommand;
})();
exports.OpenDeviceLogStreamCommand = OpenDeviceLogStreamCommand;
$injector.registerCommand("device|log", OpenDeviceLogStreamCommand);
