"use strict";
var options = require("./../../options");
var RunApplicationOnDeviceCommand = (function () {
    function RunApplicationOnDeviceCommand($devicesServices, $errors, $stringParameter, $staticConfig) {
        this.$devicesServices = $devicesServices;
        this.$errors = $errors;
        this.$stringParameter = $stringParameter;
        this.$staticConfig = $staticConfig;
        this.allowedParameters = [this.$stringParameter];
    }
    RunApplicationOnDeviceCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            _this.$devicesServices.initialize({ deviceId: options.device, skipInferPlatform: true }).wait();
            if (_this.$devicesServices.deviceCount > 1) {
                _this.$errors.fail("More than one device found. Specify device explicitly with --device option.To discover device ID, use $%s device command.", _this.$staticConfig.CLIENT_NAME.toLowerCase());
            }
            var action = function (device) {
                return (function () { return device.runApplication(args[0]).wait(); }).future()();
            };
            _this.$devicesServices.execute(action).wait();
        }).future()();
    };
    return RunApplicationOnDeviceCommand;
})();
exports.RunApplicationOnDeviceCommand = RunApplicationOnDeviceCommand;
$injector.registerCommand("device|run", RunApplicationOnDeviceCommand);
